<template>
  <div>
    <div class="article-body">
      <div class="row m-0">
        <table
          class="table table-striped table-bordered box-table m-0"
          style="background: #fff"
        >
          <thead>
            <tr>
              <th scope="col">ID</th>
              <th scope="col">Name</th>
              <th scope="col">Email</th>
              <th scope="col">Team</th>
              <th scope="col">Roles</th>
              <th class="col-1 text-center" scope="col">Action</th>
            </tr>
          </thead>
          <tbody>
            <tr v-for="(user, index) in listUser" :key="index">
              <td>{{ user.id }}</td>
              <td>
                <NuxtLink
                  :to="'/user/' + user.id"
                  style="text-decoration: none"
                  >{{ user.name }}</NuxtLink
                >
              </td>
              <td>{{ user.email }}</td>
              <td>{{ getNameTeamById(user.team_id) }}</td>
              <td>{{ getNameRoleById(user.roles) }}</td>
              <td class="text-center">
                <div
                  @click="editUser(user.id)"
                  class="btn btn-outline-primary me-1 px-2 py-1"
                  data-toggle="modal"
                  data-target="#createUpdateModal"
                >
                  <font-awesome-icon far icon="edit" />
                </div>
                <button
                  class="btn btn-outline-danger me-1 px-2 py-1"
                  @click="deleteUser(user.id)"
                >
                  <font-awesome-icon far icon="trash-alt" />
                </button>
              </td>
            </tr>
          </tbody>
        </table>
      </div>
    </div>
  </div>
</template>

<script>
import { API_TEAM, ROLE, API_USER } from '~/assets/contants/contant.js'
export default {
  data() {
    return {
      listTeam: [],
    }
  },
  props: {
    listUser: {
      type: Array,
      default: [],
    },
  },
  methods: {
    getNameTeamById(teamId) {
      const team = this.listTeam.find((team) => team.id == teamId)
      return team && team.name
    },
    async getListTeam() {
      this.listTeam = await this.$axios.$get(API_TEAM)
    },
    getNameRoleById(roleId) {
      const role = ROLE.find((role) => role.id == roleId)
      return role && role.name
    },

    async deleteUser(idUser) {
      if (confirm('Are you sure?')) {
        await this.$axios.$delete(API_USER + idUser)
        this.$emit('on-delete-user-success')
      }
    },

    editUser(idUser) {
      this.$emit('on-edit-user', idUser)
    },
  },
  mounted() {
    this.getListTeam()
  },
}
</script>

<style>
.card {
  box-shadow: 0 0 1px rgb(0 0 0 / 13%), 0 1px 3px rgb(0 0 0 / 20%);
}
.box-refresh {
  position: absolute;
  right: 1.5rem;
}
.box-new {
  position: absolute;
  right: 4.5rem;
}
</style>
